<template>
  <rui-list-item :caption="teamMate.user.username" static>
    <template #subCaption>
      <rui-badge v-if="isOwner" size="small" :caption="$t('js.map.owner')" />
      <rui-badge v-if="isUser" size="small" :caption="$t('js.generic.you')" />
      <rui-badge v-if="teamMate.user.accountState === 'pending'" size="small" variant="warning" :caption="$t('js.user.pending_activation')" />
      <rui-badge v-if="!teamMate.acceptedAt" size="small" variant="warning" :caption="$t('js.team_mates.pending_invitation')" />
    </template>
    <template #right>
      <rui-time-out-button v-if="!isUser && userIsOwner"
                           :label="$t('js.team_mates.remove')"
                           icon="x-bold"
                           no-text-on-small
                           @timed-out="removeTeamMate" />
      <rui-time-out-button v-if="isUser && !userIsOwner"
                           :label="$t('js.team_mates.leave')"
                           icon="x-bold"
                           no-text-on-small
                           @timed-out="leaveTeam" />
    </template>
  </rui-list-item>
</template>

<script>
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiTimeOutButton from '@experiments-labs/rise_ui/src/components/Inputs/TimeOutButton/TimeOutButton.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'

import TeamMate from '../../../../classes/models/TeamMate'
import Toaster from '../../../../tools/Toaster'

export default {
  name: 'GpaTeamMate',
  components: { RuiTimeOutButton, RuiBadge, RuiListItem },
  props: {
    teamMate: { required: true, type: TeamMate },
  },
  data () {
    return {
      loading: false,
      pendingDestruction: false,
      destructionTimeout: 0,
    }
  },
  computed: {
    account () { return this.$store.getters.account },
    map () { return this.$store.getters.map(parseInt(this.$route.params.mapId, 10)) },
    isOwner () { return this.map.userId === this.teamMate.user.id },
    isUser () { return this.account.id === this.teamMate.user.id },
    userIsOwner () { return this.account.id === this.map.userId },
  },
  methods: {
    removeTeamMate () {
      this.$store.dispatch('removeTeamMate', this.teamMate.id)
    },
    leaveTeam () {
      this.$store.dispatch('leaveTeamMate', this.teamMate.id)
        .then(() => {
          Toaster.success(this.$t('js.team_mates.successfully_left'))

          return this.$router.push({ name: 'home' })
            .then(() => this.$store.dispatch('loadMaps', this.teamMate.id))
        })
    },
  },
}
</script>
